-- Vorlage Voltmeter

---------------------------------------------------------------------------
-- Locale Parameter für die App
---------------------------------------------------------------------------

local lbl1, col, row, shape, rotation

local sinShape, cosShape, sinShape, cosShape, V1, V2
local heading	 	= 0																				-- Zeigerstellung
local renShape		=	lcd.renderer()
local homeShape 	= 	{  { 1, -45}, { -1,  -45}, {-3,  -7}, { 3,  -7} } 							-- Abmessungen Zeiger Spannungsmesser

local function printTelemetry()

---------------------------------------------------------------------------
-- Spannungsmesser
---------------------------------------------------------------------------
		
		local function drawShape(col, row, shape, rotation)											-- Zeiger Spannungsmesser
			
			sinShape = math.sin(rotation)   
			cosShape = math.cos(rotation)   
				renShape:reset()   for index, point in pairs(shape) do     
					renShape:addPoint(       
						col + (point[1] * cosShape - point[2] * sinShape + 0.5),       
						row + (point[1] * sinShape + point[2] * cosShape + 0.5)     
						)    
						end   
					renShape:renderPolygon() 
				end 
					
					lcd.drawImage(128, 22, imagepng_vmeter)											-- Grafik VMeter
					lcd.setColor(255,255,255)														-- Farbe Volt
					lcd.drawRectangle (126,20,59,115,4)												-- Rahmen 1 für runde Ecken
					lcd.drawRectangle (127,21,57,113,4)												-- Rahmen 2 für runde Ecken
					lcd.drawText(180 - lcd.getTextWidth(FONT_NORMAL,string.format("%s V",V1)),31,string.format("%s V",V1),FONT_NORMAL)
					lcd.drawText(180 - lcd.getTextWidth(FONT_NORMAL,string.format("%s V",V2)),101,string.format("%s V",V2),FONT_NORMAL)					
					lcd.setColor(238,044,044)														-- Farbe rot für Zeiger				
					drawShape(184, 77, homeShape, math.rad(heading-0.8))							-- Zeiger	
					lcd.drawImage(178, 71, imagepngkv)												-- Kreis für den Anfang des Zeigers

		end

---------------------------------------------------------------------------
-- Loop
---------------------------------------------------------------------------

local function loop()

		heading  = (heading + 0.25) % 360															-- Berechnung der mittleren Zeigerposition, muss nach individuellem Wert berechnet werden
		if heading >= 332 then heading = 210 end													-- Reset der Zeigerposition bei 332 Grad bei Test
		-- if heading <= 206 then heading = 206 end														-- Aktivieren für Echtbetrieb !
		-- if heading >= 334 then heading = 334 end														-- Aktivieren für Echtbetrieb !
		
		V1 = 6																							-- Obere Spannung, ersetzen durch echten Wert bei Echtbetrieb
		V2 = 0																							-- Untere Spannung, ersetzen durch echten Wert bei Echtbetrieb
		
		system.registerTelemetry(1,lbl1,4,printTelemetry)
	 
end

---------------------------------------------------------------------------
-- Initialization
---------------------------------------------------------------------------

local function init(code)

	lbl1 = "- Vorlage Spannungsmesser -"
	print ("Application initialized")

	imagepngkv 		= lcd.loadImage("Apps/img/kreisw2.png")						-- Bilddatei für Halbkreis über dem Zeiger
	imagepng_vmeter = lcd.loadImage("Apps/img/vmeter.png")						-- Bilddatei für Voltmeter

	heading = 206																-- Anfangsposition Zeiger
			
end

--------------------------------------------------------------------------------
return {init = init, loop = loop, author = "Autor", version = "Version", name = "Spannungsmesser"}
